@echo off

echo IRM 3.1.2.002: Connecting to database...

db2 connect to %1 user %2 using %3 > IRM312002.log
if %errorlevel% NEQ 0 goto FAIL

echo IRM 3.1.2.002: Checking IRM Version for upgrade...

db2 -s "call TS_Utility_GetIRMVersion(?)" >> IRM312002.log
if %errorlevel% NEQ 0 goto FAIL

echo IRM 3.1.2.002: Please wait...

db2 -s +o "select 1 from ts_cnfgrgstry where cnfgRgstryTyp = 0 AND cnfgrgstrykey = 'IRMDBVersion' AND (cnfgRgstryVal = '3.1.2.16.1 - DB2 8.1' OR cnfgRgstryVal = '3.1.2.001.1.1 - DB2')"
if NOT %errorlevel% EQU 0 (
	echo ERROR: incorrect IRM database version >> IRM312002.log
	goto FAIL
)

echo IRM 3.1.2.002: Start database upgrade to 3.1.2.002: %date% %time% >> IRM312002.log

rem DROP OLD STORED PROCEDURES

db2 -v -s drop procedure TS_FlPlnRel_FetchLstBySrcID >> IRM312002.log
if %errorlevel% NEQ 0 goto FAIL

db2 -v -s drop procedure TS_FlPlnCmpnt_SetAccCtrlPlcy >> IRM312002.log
if %errorlevel% NEQ 0 goto FAIL

db2 -v -s drop procedure TS_PermCursor_CreateRootPermCrs >> IRM312002.log
if %errorlevel% NEQ 0 goto FAIL

rem DROP OLD FUNCTIONS

db2 -v -s drop function TS_FPR_GetACPDsc >> IRM312002.log
if %errorlevel% NEQ 0 goto FAIL

rem CREATE NEW FUNCTIONS

echo Create function TS_FPR_GetACPDsc >> IRM312002.log
db2 -td@ -s -f TS_FPR_GetACPDsc.fn2 >> IRM312002.log
if %errorlevel% GEQ 4 goto FAIL

rem PUT NEW STORED PROCEDURES

echo Create procedure TS_PermCursor_CreateRootPermCrs >> IRM312002.log
db2 -td@ -s -f TS_PermCursor_CreateRootPermCrs.pr2 >> IRM312002.log
if %errorlevel% NEQ 0 goto FAIL

echo Create procedure TS_FlPlnCmpnt_SetAccCtrlPlcy >> IRM312002.log
db2 -td@ -s -f TS_FlPlnCmpnt_SetAccCtrlPlcy.pr2 >> IRM312002.log
if %errorlevel% NEQ 0 goto FAIL

echo Create procedure TS_FlPlnRel_FetchLstBySrcID >> IRM312002.log
db2 -td@ -s -f TS_FlPlnRel_FetchLstBySrcID.pr2 >> IRM312002.log
if %errorlevel% NEQ 0 goto FAIL

rem Updating version

db2 -v -s drop procedure TS_Utility_GetIRMVersion >> IRM312002.log
if %errorlevel% NEQ 0 goto FAIL
echo Create procedure TS_Utility_GetIRMVersion >> IRM312002.log
db2 -td@ -s -f TS_Utility_GetIRMVersion.pr2 >> IRM312002.log
if %errorlevel% NEQ 0 goto FAIL

rem Update the config registry table to reflect the new version

db2 -s "call TS_Utility_GetIRMVersion(?)"  >> IRM312002.log
if %errorlevel% NEQ 0 goto FAIL


rem create new index
echo Create Index IX_FPCDef#2 >> IRM312002.log

db2 -s "create index IX_FPCDef#2 on TS_FlPlnCmpntDef(FlPlnCmpntDefID, PrmViewID)"  >> IRM312002.log
if %errorlevel% NEQ 0 goto FAIL

::db2 +o terminate

echo IRM 3.1.2.002: Done.
echo IRM 3.1.2.002: Upgrade successfully completed!
echo Upgrade successfully completed! >> IRM312002.log
exit 0

:FAIL
echo IRM 3.1.2.002: Errors, check the log file
echo Errors encountered >> IRM312002.log
exit -1
